#pragma once
#include <map>
struct M_MainTaskCFGData
{
	//任务ID
	int mID;
	//任务组
	int mGroup;
	//任务类型
	int mCompleteType;
	//炮倍解锁
	std::vector<int> mCannonFold;
	//名字
	std::string mName;
	//完成计数
	int mCompleteCount;
	//特殊参数,填0不生效。对任务捕获指定鱼需要填写
	std::vector<int> mCompleteParam;
	//后续任务id
	int mNextQuestID;
	//初始化
	int mDefault;
	//奖励物品ID
	std::vector<int> mAwardItemIDs;
	//奖励物品数量
	std::vector<int> mAwardItemCounts;
	//前往类型
	int mGoType;
	//搜索范围
	std::vector<int> mFindRand;
	//转化类型
	int mShowChangeType;
};

class M_MainTaskCFG
{
public:
private:
	static std::auto_ptr<M_MainTaskCFG> msSingleton;
public:
	int GetCount();
	const M_MainTaskCFGData* GetData(int ID);
	const std::map<int, M_MainTaskCFGData>& GetMapData();
	void Load();
	void LoadLua();
	void Reload();
	static M_MainTaskCFG* GetSingleton();
	static void Release();
private:
	std::map<int, M_MainTaskCFGData> mMapData;
};
